]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
make.sh: Tidy up Git commands
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06ac8243 20# Copyright (C) 2007-2019 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
d12e3fcd 27# If you update the version don't forget to update backupiso and add it to core update
2f767b7b 28VERSION="2.25" # Version number
03d65148 29CORE="142" # Core Level (Filename)
c845152b 30PAKFIRE_CORE="141" # Core Level (PAKFIRE)
e8ee3199
AF
31SLOGAN="www.ipfire.org" # Software slogan
32CONFIG_ROOT=/var/ipfire # Configuration rootdir
33NICE=10 # Nice level
34MAX_RETRIES=1 # prefetch/check loop
305a7b38 35BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 36KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
37
38# Information from Git
39GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
40GIT_TAG="$(git tag | tail -1)" # Git Tag
41GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 42
2f767b7b 43TOOLCHAINVER=20200108
03ad5f93 44
69a6ec55
MT
45###############################################################################
46#
47# Beautifying variables & presentation & input output interface
48#
49###############################################################################
50
f9783277
MT
51# Remember if the shell is interactive or not
52if [ -t 0 ] && [ -t 1 ]; then
53 INTERACTIVE=true
54else
55 INTERACTIVE=false
56fi
57
401a1edc
MT
58# Sets or adjusts pretty formatting variables
59resize_terminal() {
60 ## Screen Dimentions
61 # Find current screen size
62 COLUMNS=$(tput cols)
63
64 # When using remote connections, such as a serial port, stty size returns 0
65 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
66 COLUMNS=80
67 fi
69a6ec55 68
401a1edc
MT
69 # Measurements for positioning result messages
70 OPTIONS_WIDTH=20
71 TIME_WIDTH=12
72 STATUS_WIDTH=8
73 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
74 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
75
e9a57acd
MT
76 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
77 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 78}
69a6ec55 79
401a1edc
MT
80# Initially setup terminal
81resize_terminal
f9783277 82
401a1edc
MT
83# Call resize_terminal when terminal is being resized
84trap "resize_terminal" WINCH
69a6ec55
MT
85
86# Define color for messages
87BOLD="\\033[1;39m"
88DONE="\\033[1;32m"
89SKIP="\\033[1;34m"
90WARN="\\033[1;35m"
91FAIL="\\033[1;31m"
92NORMAL="\\033[0;39m"
93
bcb9dc13 94# New architecture variables
dc7d6b20 95HOST_ARCH="$(uname -m)"
94571564 96
69a6ec55
MT
97PWD=$(pwd)
98BASENAME=$(basename $0)
99
15679d9f
MT
100# Debian specific settings
101if [ ! -e /etc/debian_version ]; then
df5e82b3 102 FULLPATH=`which $0`
15679d9f 103else
df5e82b3
MT
104 if [ -x /usr/bin/realpath ]; then
105 FULLPATH=`/usr/bin/realpath $0`
106 else
107 echo "ERROR: Need to do apt-get install realpath"
108 exit 1
109 fi
15679d9f 110fi
df5e82b3 111
69a6ec55 112# This is the directory where make.sh is in
aecbe123 113export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 114
ebaecf2c
AF
115LOGFILE=$BASEDIR/log/_build.preparation.log
116export LOGFILE
15679d9f 117DIR_CHK=$BASEDIR/cache/check
ebaecf2c 118mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 119
69a6ec55
MT
120system_processors() {
121 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
122}
123
124system_memory() {
125 local key val unit
126
127 while read -r key val unit; do
128 case "${key}" in
129 MemTotal:*)
130 # Convert to MB
131 echo "$(( ${val} / 1024 ))"
132 break
133 ;;
134 esac
135 done < /proc/meminfo
136}
137
138configure_build() {
139 local build_arch="${1}"
140
141 if [ "${build_arch}" = "default" ]; then
142 build_arch="$(configure_build_guess)"
143 fi
144
145 case "${build_arch}" in
146 x86_64)
147 BUILDTARGET="${build_arch}-unknown-linux-gnu"
148 CROSSTARGET="${build_arch}-cross-linux-gnu"
149 BUILD_PLATFORM="x86"
7520b95a 150 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
69a6ec55
MT
151 ;;
152
153 i586)
154 BUILDTARGET="${build_arch}-pc-linux-gnu"
155 CROSSTARGET="${build_arch}-cross-linux-gnu"
156 BUILD_PLATFORM="x86"
7520b95a 157 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
69a6ec55
MT
158 ;;
159
160 aarch64)
161 BUILDTARGET="${build_arch}-unknown-linux-gnu"
162 CROSSTARGET="${build_arch}-cross-linux-gnu"
163 BUILD_PLATFORM="arm"
840f0b9f 164 CFLAGS_ARCH=""
69a6ec55
MT
165 ;;
166
167 armv7hl)
168 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
169 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
170 BUILD_PLATFORM="arm"
171 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
172 ;;
173
174 armv5tel)
175 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
176 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
177 BUILD_PLATFORM="arm"
178 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
82454983 179 RUSTFLAGS="-Ccodegen-units=1"
69a6ec55
MT
180 ;;
181
182 *)
183 exiterror "Cannot build for architure ${build_arch}"
184 ;;
185 esac
186
187 # Check if the QEMU helper is available if needed.
188 if qemu_is_required "${build_arch}"; then
189 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
190
191 if [ -n "${qemu_build_helper}" ]; then
192 QEMU_TARGET_HELPER="${qemu_build_helper}"
193 else
194 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
195 fi
196 fi
197
198 BUILD_ARCH="${build_arch}"
199 TOOLS_DIR="/tools_${BUILD_ARCH}"
200
201 # Enables hardening
54114eb0 202 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
203
204 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
205 CXXFLAGS="${CFLAGS}"
206
207 # Determine parallelism
eeee108f 208 # We assume that each process consumes about
297473d5 209 # 128MB of memory. Therefore we find out how
eeee108f 210 # many processes fit into memory.
297473d5 211 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
eeee108f
MT
212 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
213
214 local parallelism
215 if [ ${mem_max} -lt ${cpu_max} ]; then
216 parallelism=${mem_max}
217 else
218 parallelism=${cpu_max}
69a6ec55 219 fi
212f17c1 220
eeee108f
MT
221 # Use this as default PARALLELISM
222 DEFAULT_PARALLELISM="${parallelism}"
223
212f17c1
MT
224 # Compression parameters
225 # We use mode 8 for reasonable memory usage when decompressing
226 # but with overall good compression
227 XZ_OPT="-8"
228
229 # We try to use as many cores as possible
230 XZ_OPT="${XZ_OPT} -T0"
231
232 # We need to limit memory because XZ uses too much when running
233 # in parallel and it isn't very smart in limiting itself.
234 # We allow XZ to use up to 70% of all system memory.
deffc275 235 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
236
237 # XZ memory cannot be larger than 2GB on 32 bit systems
238 case "${build_arch}" in
239 i*86|armv*)
240 if [ ${xz_memory} -gt 2048 ]; then
241 xz_memory=2048
242 fi
243 ;;
244 esac
245
246 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
247}
248
249configure_build_guess() {
250 case "${HOST_ARCH}" in
87487585
MT
251 x86_64)
252 echo "x86_64"
253 ;;
254 i?86)
69a6ec55
MT
255 echo "i586"
256 ;;
257
258 aarch64)
259 echo "aarch64"
260 ;;
261
262 armv7*|armv6*|armv5*)
263 echo "armv5tel"
264 ;;
265
266 *)
267 exiterror "Cannot guess build architecture"
268 ;;
269 esac
270}
271
f9783277
MT
272stdumount() {
273 umount $BASEDIR/build/sys 2>/dev/null;
274 umount $BASEDIR/build/dev/shm 2>/dev/null;
275 umount $BASEDIR/build/dev/pts 2>/dev/null;
276 umount $BASEDIR/build/dev 2>/dev/null;
277 umount $BASEDIR/build/proc 2>/dev/null;
278 umount $BASEDIR/build/install/mnt 2>/dev/null;
279 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
280 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
281 umount $BASEDIR/build/usr/src/config 2>/dev/null;
282 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
283 umount $BASEDIR/build/usr/src/html 2>/dev/null;
284 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
285 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 286 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 287 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 288 umount $BASEDIR/build/usr/src 2>/dev/null;
f9783277
MT
289}
290
291now() {
292 date -u "+%s"
69a6ec55
MT
293}
294
f9783277
MT
295format_runtime() {
296 local seconds=${1}
297
298 if [ ${seconds} -ge 3600 ]; then
299 printf "%d:%02d:%02d\n" \
300 "$(( seconds / 3600 ))" \
301 "$(( seconds % 3600 / 60 ))" \
302 "$(( seconds % 3600 % 60 ))"
303 elif [ ${seconds} -ge 60 ]; then
304 printf "%d:%02d\n" \
305 "$(( seconds / 60 ))" \
306 "$(( seconds % 60 ))"
69a6ec55 307 else
f9783277 308 printf "%d\n" "${seconds}"
69a6ec55 309 fi
f9783277 310}
69a6ec55 311
f9783277
MT
312print_line() {
313 local line="$@"
69a6ec55 314
f9783277 315 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
316}
317
f9783277
MT
318_print_line() {
319 local status="${1}"
320 shift
69a6ec55 321
f9783277
MT
322 if ${INTERACTIVE}; then
323 printf "${!status}"
324 fi
69a6ec55 325
f9783277
MT
326 print_line "$@"
327
328 if ${INTERACTIVE}; then
329 printf "${NORMAL}"
330 fi
331}
332
333print_headline() {
334 _print_line BOLD "$@"
69a6ec55
MT
335}
336
f9783277
MT
337print_error() {
338 _print_line FAIL "$@"
339}
340
341print_package() {
342 local name="${1}"
343 shift
69a6ec55 344
f9783277
MT
345 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
346 local options="$@"
347
348 local string="${name}"
349 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
350 string="${string} (${version})"
351 fi
352
353 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 354 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
355}
356
357print_runtime() {
358 local runtime=$(format_runtime $@)
359
360 if ${INTERACTIVE}; then
361 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
362 else
363 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 364 fi
f9783277
MT
365}
366
367print_status() {
368 local status="${1}"
369
370 local color="${!status}"
371
372 if ${INTERACTIVE}; then
373 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
374 else
375 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 376 fi
f9783277 377}
69a6ec55 378
f9783277
MT
379print_build_stage() {
380 print_headline "$@"
381
382 # end line
383 printf "\n"
69a6ec55
MT
384}
385
f9783277
MT
386print_build_summary() {
387 local runtime=$(format_runtime $@)
388
389 print_line "*** Build finished in ${runtime}"
390 print_status DONE
69a6ec55
MT
391}
392
393exiterror() {
394 stdumount
395 for i in `seq 0 7`; do
396 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
397 losetup -d /dev/loop${i} 2>/dev/null
398 fi;
399 done
400
f9783277 401 # Dump logfile
66028310 402 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
403 echo # empty line
404
405 local line
406 while read -r line; do
407 echo " ${line}"
408 done <<< "$(tail -n30 ${LOGFILE})"
409 fi
410
f9783277
MT
411 echo # empty line
412
413 local line
414 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
415 print_error "${line}"
416 print_status FAIL
417 done
418
69a6ec55
MT
419 exit 1
420}
421
aecbe123
MT
422prepareenv() {
423 # Are we running the right shell?
54328605 424 if [ -z "${BASH}" ]; then
aecbe123
MT
425 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
426 fi
427
428 if [ -z "${BASH_VERSION}" ]; then
429 exiterror "Not running BASH shell."
430 fi
431
432 # Trap on emergency exit
433 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
434
435 # Resetting our nice level
658232a6 436 if ! renice ${NICE} $$ >/dev/null; then
658232a6 437 exiterror "Failed to set nice level to ${NICE}"
aecbe123
MT
438 fi
439
440 # Checking if running as root user
658232a6 441 if [ $(id -u) -ne 0 ]; then
df7f30a1 442 exiterror "root privileges required for building"
aecbe123
MT
443 fi
444
445 # Checking for necessary temporary space
f9783277 446 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
447 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
448 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
449 if (( 2048000 > $BASE_ASPACE )); then
450 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
451 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 452 print_status FAIL
aecbe123
MT
453 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
454 fi
455 else
f9783277 456 print_status DONE
aecbe123
MT
457 fi
458
459 # Set umask
460 umask 022
461
462 # Set LFS Directory
463 LFS=$BASEDIR/build
464
aecbe123
MT
465 # Setup environment
466 set +h
467 LC_ALL=POSIX
82454983 468 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
aecbe123
MT
469 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
470
471 # Make some extra directories
472 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
473 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
474 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
3608d485 475 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
7c984de6
MT
476
477 if [ "${ENABLE_RAMDISK}" = "on" ]; then
478 mkdir -p $BASEDIR/build/usr/src
92fbca34 479 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
7c984de6
MT
480 fi
481
ebaecf2c 482 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
483
484 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
485 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
486
487 # Make all sources and proc available under lfs build
488 mount --bind /dev $BASEDIR/build/dev
489 mount --bind /dev/pts $BASEDIR/build/dev/pts
490 mount --bind /dev/shm $BASEDIR/build/dev/shm
491 mount --bind /proc $BASEDIR/build/proc
492 mount --bind /sys $BASEDIR/build/sys
493 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
3608d485 494 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
aecbe123
MT
495 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
496 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
497 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
498 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
499 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 500 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
501 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
502
503 # Run LFS static binary creation scripts one by one
504 export CCACHE_DIR=$BASEDIR/ccache
505 export CCACHE_COMPRESS=1
506 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
507
508 # Remove pre-install list of installed files in case user erase some files before rebuild
509 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
510
511 # Prepare string for /etc/system-release.
512 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
513 if [ "$(git status -s | wc -l)" == "0" ]; then
514 GIT_STATUS=""
515 else
516 GIT_STATUS="-dirty"
517 fi
518 case "$GIT_BRANCH" in
519 core*|beta?|rc?)
520 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
521 ;;
522 *)
36e2e992 523 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/${GIT_LASTCOMMIT:0:8}$GIT_STATUS"
aecbe123
MT
524 ;;
525 esac
4e54a8e2
MT
526
527 # Setup ccache cache size
528 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
aecbe123
MT
529}
530
69a6ec55
MT
531enterchroot() {
532 # Install QEMU helper, if needed
533 qemu_install_helper
534
535 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
536
537 PATH="${PATH}" chroot ${LFS} env -i \
538 HOME="/root" \
539 TERM="${TERM}" \
540 PS1="${PS1}" \
541 PATH="${PATH}" \
542 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
543 PAKFIRE_CORE="${PAKFIRE_CORE}" \
544 NAME="${NAME}" \
545 SNAME="${SNAME}" \
546 VERSION="${VERSION}" \
547 CORE="${CORE}" \
548 SLOGAN="${SLOGAN}" \
549 TOOLS_DIR="${TOOLS_DIR}" \
550 CONFIG_ROOT="${CONFIG_ROOT}" \
551 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
552 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 553 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
554 BUILDTARGET="${BUILDTARGET}" \
555 CROSSTARGET="${CROSSTARGET}" \
556 BUILD_ARCH="${BUILD_ARCH}" \
557 BUILD_PLATFORM="${BUILD_PLATFORM}" \
558 CCACHE_DIR=/usr/src/ccache \
559 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
560 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 561 GOCACHE="/usr/src/ccache/go" \
69a6ec55 562 KVER="${KVER}" \
0d7a6f03 563 XZ_OPT="${XZ_OPT}" \
77c863a2 564 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
565 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
566 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
567 $(fake_environ) \
568 $(qemu_environ) \
569 "$@"
570}
571
572entershell() {
573 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
574 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
575 fi
576
577 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 578 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
579
580 if enterchroot bash -i; then
581 stdumount
582 else
f9783277 583 print_status FAIL
69a6ec55
MT
584 exiterror "chroot error"
585 fi
586}
587
588lfsmakecommoncheck() {
589 # Script present?
590 if [ ! -f $BASEDIR/lfs/$1 ]; then
591 exiterror "No such file or directory: $BASEDIR/$1"
592 fi
593
f9783277
MT
594 # Print package name and version
595 print_package $@
69a6ec55
MT
596
597 # Check if this package is supported by our architecture.
598 # If no SUP_ARCH is found, we assume the package can be built for all.
599 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
600 # Check if package supports ${BUILD_ARCH} or all architectures.
601 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 602 print_runtime 0
f9783277 603 print_status SKIP
69a6ec55
MT
604 return 1
605 fi
606 fi
607
608 # Script slipped?
609 local i
610 for i in $SKIP_PACKAGE_LIST
611 do
612 if [ "$i" == "$1" ]; then
f9783277 613 print_status SKIP
69a6ec55
MT
614 return 1;
615 fi
616 done
617
618 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
619
620 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
621 MESSAGE="$1\t " download >> $LOGFILE 2>&1
622 if [ $? -ne 0 ]; then
623 exiterror "Download error in $1"
624 fi
625
626 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
627 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
628 if [ $? -ne 0 ]; then
629 exiterror "md5sum error in $1, check file in cache or signature"
630 fi
631
632 return 0 # pass all!
633}
634
635lfsmake1() {
636 lfsmakecommoncheck $*
637 [ $? == 1 ] && return 0
638
69a6ec55
MT
639 cd $BASEDIR/lfs && env -i \
640 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
641 CCACHE_DIR="${CCACHE_DIR}" \
642 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
643 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
644 CFLAGS="${CFLAGS}" \
645 CXXFLAGS="${CXXFLAGS}" \
77c863a2 646 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
647 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
648 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
649 make -f $* \
650 TOOLCHAIN=1 \
651 TOOLS_DIR="${TOOLS_DIR}" \
652 CROSSTARGET="${CROSSTARGET}" \
653 BUILDTARGET="${BUILDTARGET}" \
654 BUILD_ARCH="${BUILD_ARCH}" \
655 BUILD_PLATFORM="${BUILD_PLATFORM}" \
656 LFS_BASEDIR="${BASEDIR}" \
657 ROOT="${LFS}" \
658 KVER="${KVER}" \
f9783277 659 install >> $LOGFILE 2>&1 &
69a6ec55 660
f9783277
MT
661 if ! wait_until_finished $!; then
662 print_status FAIL
663 exiterror "Building $*"
69a6ec55
MT
664 fi
665
f9783277 666 print_status DONE
69a6ec55
MT
667}
668
669lfsmake2() {
670 lfsmakecommoncheck $*
671 [ $? == 1 ] && return 0
672
69a6ec55
MT
673 local PS1='\u:\w$ '
674
675 enterchroot \
ce9264a1 676 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
677 make -f $* \
678 LFS_BASEDIR=/usr/src install" \
f9783277 679 >> ${LOGFILE} 2>&1 &
69a6ec55 680
f9783277
MT
681 if ! wait_until_finished $!; then
682 print_status FAIL
683 exiterror "Building $*"
69a6ec55
MT
684 fi
685
f9783277 686 print_status DONE
69a6ec55
MT
687}
688
689ipfiredist() {
690 lfsmakecommoncheck $*
691 [ $? == 1 ] && return 0
692
69a6ec55
MT
693 local PS1='\u:\w$ '
694
695 enterchroot \
696 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 697 >> ${LOGFILE} 2>&1 &
69a6ec55 698
f9783277
MT
699 if ! wait_until_finished $!; then
700 print_status FAIL
701 exiterror "Packaging $*"
702 fi
69a6ec55 703
f9783277
MT
704 print_status DONE
705}
706
707wait_until_finished() {
708 local pid=${1}
709
710 local start_time=$(now)
711
712 # Show progress
713 if ${INTERACTIVE}; then
714 # Wait a little just in case the process
715 # has finished very quickly.
716 sleep 0.1
717
718 local runtime
719 while kill -0 ${pid} 2>/dev/null; do
720 print_runtime $(( $(now) - ${start_time} ))
721
722 # Wait a little
723 sleep 1
724 done
69a6ec55 725 fi
f9783277
MT
726
727 # Returns the exit code of the child process
728 wait ${pid}
729 local ret=$?
730
731 if ! ${INTERACTIVE}; then
732 print_runtime $(( $(now) - ${start_time} ))
733 fi
734
735 return ${ret}
69a6ec55
MT
736}
737
738fake_environ() {
739 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
740
741 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
742
743 # Fake kernel version, because some of the packages do not compile
744 # with kernel 3.0 and later.
8634797e 745 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
746
747 # Fake machine version.
748 env="${env} UTS_MACHINE=${BUILD_ARCH}"
749
750 echo "${env}"
751}
752
753qemu_environ() {
754 local env
755
756 # Don't add anything if qemu is not used.
757 if ! qemu_is_required; then
758 return
759 fi
760
761 # Set default qemu options
762 case "${BUILD_ARCH}" in
763 arm*)
764 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
765
766 env="${env} QEMU_CPU=${QEMU_CPU}"
767 ;;
768 esac
769
770 # Enable QEMU strace
771 #env="${env} QEMU_STRACE=1"
772
773 echo "${env}"
774}
775
776qemu_is_required() {
777 local build_arch="${1}"
778
779 if [ -z "${build_arch}" ]; then
780 build_arch="${BUILD_ARCH}"
781 fi
782
783 case "${HOST_ARCH},${build_arch}" in
784 x86_64,arm*|i?86,arm*|i?86,x86_64)
785 return 0
786 ;;
787 *)
788 return 1
789 ;;
790 esac
791}
792
793qemu_install_helper() {
794 # Do nothing, if qemu is not required
795 if ! qemu_is_required; then
796 return 0
797 fi
798
799 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
800 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
801 fi
802
803 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
804 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
805 fi
806
807
808 if [ -z "${QEMU_TARGET_HELPER}" ]; then
809 exiterror "QEMU_TARGET_HELPER not set"
810 fi
811
812 # Check if the helper is already installed.
813 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
814 return 0
815 fi
816
817 # Try to find a suitable binary that we can install
818 # to the build environment.
819 local file
820 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
821 # file must exist and be executable.
822 [ -x "${file}" ] || continue
823
824 # Must be static.
825 file_is_static "${file}" || continue
826
827 local dirname="${LFS}$(dirname "${file}")"
828 mkdir -p "${dirname}"
829
830 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
831 return 0
832 done
833
834 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
835}
836
837qemu_find_build_helper_name() {
838 local build_arch="${1}"
839
840 local magic
841 case "${build_arch}" in
842 arm*)
843 magic="7f454c4601010100000000000000000002002800"
844 ;;
845 x86_64)
846 magic="7f454c4602010100000000000000000002003e00"
847 ;;
848 esac
849
850 [ -z "${magic}" ] && return 1
851
852 local file
853 for file in /proc/sys/fs/binfmt_misc/*; do
854 # skip write only register entry
855 [ $(basename "${file}") = "register" ] && continue
856 # Search for the file with the correct magic value.
857 grep -qE "^magic ${magic}$" "${file}" || continue
858
859 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
860
861 [ -n "${interpreter}" ] || continue
862 [ "${interpreter:0:1}" = "/" ] || continue
863 [ -x "${interpreter}" ] || continue
864
865 echo "${interpreter}"
866 return 0
867 done
868
869 return 1
870}
871
872file_is_static() {
873 local file="${1}"
874
875 file ${file} 2>/dev/null | grep -q "statically linked"
876}
877
878update_language_list() {
879 local path="${1}"
880
881 local lang
882 for lang in ${path}/*.po; do
883 lang="$(basename "${lang}")"
884 echo "${lang%*.po}"
885 done | sort -u > "${path}/LINGUAS"
886}
887
1fb7f56e
MT
888contributors() {
889 local commits name
890
891 git shortlog --summary --numbered | while read -r commits name; do
892 echo "${name}"
893 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
894}
895
896update_contributors() {
897 echo -n "Updating list of contributors"
898
899 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
900
901 # Edit contributors into credits.cgi
e2338aa7
MT
902 local tmp="$(mktemp)"
903
904 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
905 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
906
907 # Copy back modified content
908 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
909 unlink "${tmp}"
1fb7f56e
MT
910
911 print_status DONE
912 return 0
913}
914
15b005d8 915# Default settings
99597de7 916CCACHE_CACHE_SIZE="4G"
15b005d8
MT
917ENABLE_RAMDISK="auto"
918
a98ab1d7
MT
919# Load configuration file
920if [ -f .config ]; then
921 . .config
922fi
923
813659f2
MT
924# TARGET_ARCH is BUILD_ARCH now
925if [ -n "${TARGET_ARCH}" ]; then
926 BUILD_ARCH="${TARGET_ARCH}"
927 unset TARGET_ARCH
928fi
929
85560933
MT
930# Get some information about the host system
931SYSTEM_PROCESSORS="$(system_processors)"
932SYSTEM_MEMORY="$(system_memory)"
933
dc7d6b20
MT
934if [ -n "${BUILD_ARCH}" ]; then
935 configure_build "${BUILD_ARCH}"
949544f5 936else
dc7d6b20 937 configure_build "default"
949544f5
MT
938fi
939
15b005d8
MT
940# Automatically enable/disable ramdisk usage
941if [ "${ENABLE_RAMDISK}" = "auto" ]; then
942 # Enable only when the host system has 4GB of RAM or more
943 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
944 ENABLE_RAMDISK="on"
945 fi
946fi
947
df5e82b3 948buildtoolchain() {
69a6ec55
MT
949 local error=false
950 case "${BUILD_ARCH}:${HOST_ARCH}" in
951 # x86_64
952 x86_64:x86_64)
953 # This is working.
954 ;;
955
956 # x86
957 i586:i586|i586:i686|i586:x86_64)
958 # These are working.
959 ;;
960 i586:*)
961 error=true
962 ;;
963
964 # ARM
965 arvm7hl:armv7hl|armv7hl:armv7l)
966 # These are working.
967 ;;
968
969 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
970 # These are working.
971 ;;
972 armv5tel:*)
973 error=true
974 ;;
975 esac
976
977 ${error} && \
978 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
979
980 local gcc=$(type -p gcc)
981 if [ -z "${gcc}" ]; then
982 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
983 fi
984
6bd3a131
MT
985 # Check ${TOOLS_DIR} symlink
986 if [ -h "${TOOLS_DIR}" ]; then
987 rm -f "${TOOLS_DIR}"
988 fi
989
990 if [ ! -e "${TOOLS_DIR}" ]; then
991 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
992 fi
993
994 if [ ! -h "${TOOLS_DIR}" ]; then
995 exiterror "Could not create ${TOOLS_DIR} symbolic link"
996 fi
997
ebaecf2c 998 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
999 export LOGFILE
1000
1001 lfsmake1 stage1
1002 lfsmake1 ccache PASS=1
1003 lfsmake1 binutils PASS=1
1004 lfsmake1 gcc PASS=1
1005 lfsmake1 linux KCFG="-headers"
1006 lfsmake1 glibc
1007 lfsmake1 gcc PASS=L
1008 lfsmake1 binutils PASS=2
1009 lfsmake1 gcc PASS=2
54d54148 1010 lfsmake1 zlib
69a6ec55
MT
1011 lfsmake1 ccache PASS=2
1012 lfsmake1 tcl
1013 lfsmake1 expect
1014 lfsmake1 dejagnu
1015 lfsmake1 pkg-config
1016 lfsmake1 ncurses
1017 lfsmake1 bash
1018 lfsmake1 bzip2
1019 lfsmake1 automake
1020 lfsmake1 coreutils
1021 lfsmake1 diffutils
1022 lfsmake1 findutils
1023 lfsmake1 gawk
1024 lfsmake1 gettext
1025 lfsmake1 grep
1026 lfsmake1 gzip
1027 lfsmake1 m4
1028 lfsmake1 make
1029 lfsmake1 patch
1030 lfsmake1 perl
46bbc13b 1031 lfsmake1 python3
69a6ec55
MT
1032 lfsmake1 sed
1033 lfsmake1 tar
1034 lfsmake1 texinfo
1035 lfsmake1 xz
85439ac7 1036 lfsmake1 bison
11b5e5cb 1037 lfsmake1 flex
69a6ec55 1038 lfsmake1 fake-environ
7b93b62b 1039 lfsmake1 strip
69a6ec55 1040 lfsmake1 cleanup-toolchain
df5e82b3
MT
1041}
1042
1043buildbase() {
ebaecf2c 1044 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1045 export LOGFILE
1046 lfsmake2 stage2
1047 lfsmake2 linux KCFG="-headers"
1048 lfsmake2 man-pages
1049 lfsmake2 glibc
1050 lfsmake2 tzdata
1051 lfsmake2 cleanup-toolchain
1052 lfsmake2 zlib
1053 lfsmake2 binutils
1054 lfsmake2 gmp
1055 lfsmake2 gmp-compat
1056 lfsmake2 mpfr
1057 lfsmake2 libmpc
1058 lfsmake2 file
1059 lfsmake2 gcc
1060 lfsmake2 sed
1061 lfsmake2 autoconf
1062 lfsmake2 automake
1063 lfsmake2 berkeley
1064 lfsmake2 coreutils
1065 lfsmake2 iana-etc
1066 lfsmake2 m4
1067 lfsmake2 bison
69a6ec55
MT
1068 lfsmake2 ncurses
1069 lfsmake2 procps
1070 lfsmake2 libtool
1071 lfsmake2 perl
1072 lfsmake2 readline
1073 lfsmake2 readline-compat
1074 lfsmake2 bzip2
3ece7859 1075 lfsmake2 xz
69a6ec55
MT
1076 lfsmake2 pcre
1077 lfsmake2 pcre-compat
1078 lfsmake2 bash
1079 lfsmake2 diffutils
1080 lfsmake2 e2fsprogs
1081 lfsmake2 ed
1082 lfsmake2 findutils
1083 lfsmake2 flex
1084 lfsmake2 gawk
1085 lfsmake2 gettext
1086 lfsmake2 grep
1087 lfsmake2 groff
1088 lfsmake2 gperf
1089 lfsmake2 gzip
1090 lfsmake2 hostname
1091 lfsmake2 iproute2
1092 lfsmake2 jwhois
1093 lfsmake2 kbd
1094 lfsmake2 less
4720fa0d 1095 lfsmake2 pkg-config
69a6ec55
MT
1096 lfsmake2 make
1097 lfsmake2 man
1098 lfsmake2 kmod
1099 lfsmake2 net-tools
1100 lfsmake2 patch
1101 lfsmake2 psmisc
1102 lfsmake2 shadow
1103 lfsmake2 sysklogd
1104 lfsmake2 sysvinit
1105 lfsmake2 tar
1106 lfsmake2 texinfo
1107 lfsmake2 util-linux
1108 lfsmake2 udev
1109 lfsmake2 vim
df5e82b3
MT
1110}
1111
15679d9f 1112buildipfire() {
ebaecf2c 1113 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1114 export LOGFILE
489145db
MT
1115 lfsmake2 configroot
1116 lfsmake2 initscripts
1117 lfsmake2 backup
c38f55fe
MT
1118 lfsmake2 openssl
1119 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
3755e358 1120 lfsmake2 popt
d4767896 1121 lfsmake2 libedit
489145db
MT
1122 lfsmake2 libusb
1123 lfsmake2 libusb-compat
1124 lfsmake2 libpcap
1125 lfsmake2 ppp
1126 lfsmake2 pptp
1127 lfsmake2 unzip
1128 lfsmake2 which
1129 lfsmake2 linux-firmware
489145db 1130 lfsmake2 dvb-firmwares
37b86fa9 1131 lfsmake2 xr819-firmware
489145db
MT
1132 lfsmake2 zd1211-firmware
1133 lfsmake2 rpi-firmware
26796f3a 1134 lfsmake2 intel-microcode
0e54ca26 1135 lfsmake2 pcengines-apu-firmware
489145db 1136 lfsmake2 bc
2a0947f2 1137 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1138 lfsmake2 cpio
1139 lfsmake2 mdadm
1140 lfsmake2 dracut
de18b4de 1141 lfsmake2 libaio
489145db
MT
1142 lfsmake2 lvm2
1143 lfsmake2 multipath-tools
1144 lfsmake2 freetype
489145db
MT
1145 lfsmake2 libmnl
1146 lfsmake2 libnfnetlink
1147 lfsmake2 libnetfilter_queue
1148 lfsmake2 libnetfilter_conntrack
1149 lfsmake2 libnetfilter_cthelper
1150 lfsmake2 libnetfilter_cttimeout
1151 lfsmake2 iptables
0245f3b6 1152 lfsmake2 screen
54ead8ef 1153 lfsmake2 elfutils
8e6fb99d 1154
dc7d6b20 1155 case "${BUILD_ARCH}" in
68a36e26 1156 x86_64|aarch64)
489145db 1157 lfsmake2 linux KCFG=""
b389d731
AF
1158# lfsmake2 backports KCFG=""
1159# lfsmake2 e1000e KCFG=""
1160# lfsmake2 igb KCFG=""
1161# lfsmake2 ixgbe KCFG=""
489145db
MT
1162 lfsmake2 xtables-addons KCFG=""
1163 lfsmake2 linux-initrd KCFG=""
fc155193 1164 ;;
3d02c091
MT
1165 i586)
1166 # x86-pae (Native and new XEN) kernel build
489145db 1167 lfsmake2 linux KCFG="-pae"
b389d731
AF
1168# lfsmake2 backports KCFG="-pae"
1169# lfsmake2 e1000e KCFG="-pae"
1170# lfsmake2 igb KCFG="-pae"
1171# lfsmake2 ixgbe KCFG="-pae"
489145db
MT
1172 lfsmake2 xtables-addons KCFG="-pae"
1173 lfsmake2 linux-initrd KCFG="-pae"
3d02c091
MT
1174
1175 # x86 kernel build
489145db 1176 lfsmake2 linux KCFG=""
b389d731
AF
1177# lfsmake2 backports KCFG=""
1178# lfsmake2 e1000e KCFG=""
1179# lfsmake2 igb KCFG=""
1180# lfsmake2 ixgbe KCFG=""
489145db
MT
1181 lfsmake2 xtables-addons KCFG=""
1182 lfsmake2 linux-initrd KCFG=""
3d02c091 1183 ;;
544f40d4 1184
3d02c091 1185 armv5tel)
3d02c091 1186 # arm multi platform (Panda, Wandboard ...) kernel build
489145db 1187 lfsmake2 linux KCFG="-multi"
0a21d63f
AF
1188# lfsmake2 backports KCFG="-multi"
1189# lfsmake2 e1000e KCFG="-multi"
1190# lfsmake2 igb KCFG="-multi"
1191# lfsmake2 ixgbe KCFG="-multi"
489145db
MT
1192 lfsmake2 xtables-addons KCFG="-multi"
1193 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1194 ;;
1195 esac
489145db 1196 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1197 lfsmake2 libgpg-error
1198 lfsmake2 libgcrypt
1199 lfsmake2 libassuan
1200 lfsmake2 nettle
1a7db134 1201 lfsmake2 json-c
f3e62301 1202 lfsmake2 libconfig
489145db
MT
1203 lfsmake2 libevent
1204 lfsmake2 libevent2
1205 lfsmake2 expat
c8e9a7a8
WA
1206 lfsmake2 apr
1207 lfsmake2 aprutil
489145db
MT
1208 lfsmake2 unbound
1209 lfsmake2 gnutls
1210 lfsmake2 bind
1211 lfsmake2 dhcp
1212 lfsmake2 dhcpcd
1213 lfsmake2 boost
1214 lfsmake2 linux-atm
1215 lfsmake2 gdbm
1216 lfsmake2 pam
1217 lfsmake2 curl
1218 lfsmake2 tcl
1219 lfsmake2 sqlite
1220 lfsmake2 libffi
1221 lfsmake2 python
1222 lfsmake2 python3
b3ce3510
MT
1223 lfsmake2 grub
1224 lfsmake2 efivar
1225 lfsmake2 efibootmgr
489145db
MT
1226 lfsmake2 ca-certificates
1227 lfsmake2 fireinfo
1228 lfsmake2 libnet
1229 lfsmake2 libnl
1230 lfsmake2 libnl-3
1231 lfsmake2 libidn
1232 lfsmake2 nasm
1233 lfsmake2 libjpeg
1234 lfsmake2 libjpeg-compat
1235 lfsmake2 libexif
1236 lfsmake2 libpng
1237 lfsmake2 libtiff
1238 lfsmake2 libart
1239 lfsmake2 gd
489145db
MT
1240 lfsmake2 slang
1241 lfsmake2 newt
1242 lfsmake2 libsmooth
1243 lfsmake2 attr
1244 lfsmake2 acl
1245 lfsmake2 libcap
b051eb68 1246 lfsmake2 libcap-ng
489145db
MT
1247 lfsmake2 pciutils
1248 lfsmake2 usbutils
1249 lfsmake2 libxml2
1250 lfsmake2 libxslt
1251 lfsmake2 BerkeleyDB
489145db
MT
1252 lfsmake2 cyrus-sasl
1253 lfsmake2 openldap
1254 lfsmake2 apache2
489145db
MT
1255 lfsmake2 web-user-interface
1256 lfsmake2 flag-icons
1257 lfsmake2 jquery
6033b271 1258 lfsmake2 bootstrap
489145db
MT
1259 lfsmake2 arping
1260 lfsmake2 beep
78dd680d
MT
1261 lfsmake2 libarchive
1262 lfsmake2 cmake
1df47cc9 1263 lfsmake2 libssh
8a960584 1264 lfsmake2 cdrkit
489145db
MT
1265 lfsmake2 dosfstools
1266 lfsmake2 reiserfsprogs
1267 lfsmake2 xfsprogs
1268 lfsmake2 sysfsutils
1269 lfsmake2 fuse
1270 lfsmake2 ntfs-3g
1271 lfsmake2 ethtool
1272 lfsmake2 ez-ipupdate
1273 lfsmake2 fcron
1274 lfsmake2 perl-GD
1275 lfsmake2 GD-Graph
1276 lfsmake2 GD-TextUtil
1277 lfsmake2 perl-Device-SerialPort
1278 lfsmake2 perl-Device-Modem
1279 lfsmake2 perl-Apache-Htpasswd
1280 lfsmake2 gnupg
1281 lfsmake2 hdparm
1282 lfsmake2 sdparm
1283 lfsmake2 mtools
1284 lfsmake2 whatmask
1285 lfsmake2 conntrack-tools
1286 lfsmake2 libupnp
1287 lfsmake2 ipaddr
1288 lfsmake2 iputils
1289 lfsmake2 l7-protocols
489145db
MT
1290 lfsmake2 hwdata
1291 lfsmake2 logrotate
1292 lfsmake2 logwatch
1293 lfsmake2 misc-progs
1294 lfsmake2 nano
1295 lfsmake2 URI
294aa009
AF
1296 lfsmake2 perl-CGI
1297 lfsmake2 perl-Switch
489145db
MT
1298 lfsmake2 HTML-Tagset
1299 lfsmake2 HTML-Parser
1300 lfsmake2 HTML-Template
1301 lfsmake2 Compress-Zlib
1302 lfsmake2 Digest
1303 lfsmake2 Digest-SHA1
1304 lfsmake2 Digest-HMAC
1305 lfsmake2 libwww-perl
1306 lfsmake2 Net-DNS
1307 lfsmake2 Net-IPv4Addr
1308 lfsmake2 Net_SSLeay
1309 lfsmake2 IO-Stringy
1310 lfsmake2 IO-Socket-SSL
1311 lfsmake2 Unix-Syslog
1312 lfsmake2 Mail-Tools
1313 lfsmake2 MIME-Tools
1314 lfsmake2 Net-Server
1315 lfsmake2 Convert-TNEF
1316 lfsmake2 Convert-UUlib
1317 lfsmake2 Archive-Tar
1318 lfsmake2 Archive-Zip
1319 lfsmake2 Text-Tabs+Wrap
1320 lfsmake2 Locale-Country
1321 lfsmake2 XML-Parser
1322 lfsmake2 Crypt-PasswdMD5
1323 lfsmake2 Net-Telnet
1324 lfsmake2 python-setuptools
1325 lfsmake2 python-clientform
1326 lfsmake2 python-mechanize
1327 lfsmake2 python-feedparser
1328 lfsmake2 python-rssdler
1329 lfsmake2 python-inotify
1330 lfsmake2 python-docutils
1331 lfsmake2 python-daemon
1332 lfsmake2 python-ipaddress
1333 lfsmake2 glib
f107bb39 1334 lfsmake2 GeoIP
eba8e481 1335 lfsmake2 geoip-database
489145db
MT
1336 lfsmake2 ntp
1337 lfsmake2 openssh
1338 lfsmake2 fontconfig
1339 lfsmake2 dejavu-fonts-ttf
70f6cba4 1340 lfsmake2 ubuntu-font-family
489145db
MT
1341 lfsmake2 freefont
1342 lfsmake2 pixman
1343 lfsmake2 cairo
1344 lfsmake2 pango
1345 lfsmake2 rrdtool
1346 lfsmake2 setserial
1347 lfsmake2 setup
1348 lfsmake2 libdnet
59fe9735 1349 lfsmake2 rust
616395f3 1350 lfsmake2 jansson
91cc908f 1351 lfsmake2 yaml
3498300d 1352 lfsmake2 libhtp
1a5f0649 1353 lfsmake2 colm
2348cfff 1354 lfsmake2 ragel
52ebc66b 1355 lfsmake2 hyperscan
67752a95 1356 lfsmake2 suricata
489145db 1357 lfsmake2 oinkmaster
ef640882 1358 lfsmake2 ids-ruleset-sources
489145db
MT
1359 lfsmake2 squid
1360 lfsmake2 squidguard
1361 lfsmake2 calamaris
1362 lfsmake2 tcpdump
1363 lfsmake2 traceroute
1364 lfsmake2 vlan
1365 lfsmake2 wireless
1366 lfsmake2 pakfire
1367 lfsmake2 spandsp
adf3f4f4 1368 lfsmake2 lz4
489145db
MT
1369 lfsmake2 lzo
1370 lfsmake2 openvpn
489145db
MT
1371 lfsmake2 mpage
1372 lfsmake2 dbus
1373 lfsmake2 intltool
1374 lfsmake2 libdaemon
6064cd87 1375 lfsmake2 avahi
489145db 1376 lfsmake2 cups
489145db 1377 lfsmake2 lcms2
56170c2a 1378 lfsmake2 ghostscript
489145db
MT
1379 lfsmake2 qpdf
1380 lfsmake2 poppler
1381 lfsmake2 cups-filters
1382 lfsmake2 epson-inkjet-printer-escpr
1383 lfsmake2 foomatic
1384 lfsmake2 hplip
1385 lfsmake2 cifs-utils
1386 lfsmake2 krb5
1387 lfsmake2 samba
1388 lfsmake2 sudo
1389 lfsmake2 mc
1390 lfsmake2 wget
1391 lfsmake2 bridge-utils
489145db
MT
1392 lfsmake2 smartmontools
1393 lfsmake2 htop
1394 lfsmake2 chkconfig
1395 lfsmake2 postfix
1396 lfsmake2 fetchmail
1397 lfsmake2 cyrus-imapd
489145db 1398 lfsmake2 clamav
294aa009 1399 lfsmake2 perl-NetAddr-IP
489145db 1400 lfsmake2 spamassassin
438edc64 1401 lfsmake2 perl-Net-LibIDN
489145db
MT
1402 lfsmake2 amavisd
1403 lfsmake2 dma
1404 lfsmake2 alsa
1405 lfsmake2 mpfire
1406 lfsmake2 guardian
1407 lfsmake2 libid3tag
1408 lfsmake2 libmad
1409 lfsmake2 libogg
1410 lfsmake2 libvorbis
1411 lfsmake2 libdvbpsi
1412 lfsmake2 flac
1413 lfsmake2 lame
1414 lfsmake2 sox
41f8d642 1415 lfsmake2 soxr
489145db
MT
1416 lfsmake2 libshout
1417 lfsmake2 xvid
1418 lfsmake2 libmpeg2
489145db
MT
1419 lfsmake2 gnump3d
1420 lfsmake2 rsync
489145db
MT
1421 lfsmake2 libtirpc
1422 lfsmake2 rpcbind
14fb55a5 1423 lfsmake2 keyutils
489145db
MT
1424 lfsmake2 nfs
1425 lfsmake2 gnu-netcat
1426 lfsmake2 ncat
1427 lfsmake2 nmap
489145db
MT
1428 lfsmake2 etherwake
1429 lfsmake2 bwm-ng
1430 lfsmake2 sysstat
489145db
MT
1431 lfsmake2 strongswan
1432 lfsmake2 rng-tools
1433 lfsmake2 lsof
1434 lfsmake2 br2684ctl
1435 lfsmake2 pcmciautils
1436 lfsmake2 lm_sensors
1437 lfsmake2 liboping
1438 lfsmake2 collectd
1439 lfsmake2 elinks
1440 lfsmake2 igmpproxy
1441 lfsmake2 fbset
1442 lfsmake2 opus
1443 lfsmake2 python-six
1444 lfsmake2 python-pyparsing
1445 lfsmake2 spice-protocol
1446 lfsmake2 spice
1447 lfsmake2 sdl
1448 lfsmake2 libusbredir
43c3a386 1449 lfsmake2 libseccomp
489145db
MT
1450 lfsmake2 qemu
1451 lfsmake2 sane
1452 lfsmake2 netpbm
489145db 1453 lfsmake2 netsnmpd
489145db 1454 lfsmake2 nagios_nrpe
2af354c2 1455 lfsmake2 nagios-plugins
489145db 1456 lfsmake2 icinga
01c2ea6b 1457 lfsmake2 observium-agent
489145db
MT
1458 lfsmake2 ebtables
1459 lfsmake2 directfb
489145db 1460 lfsmake2 faad2
e91ceed6 1461 lfsmake2 alac
489145db
MT
1462 lfsmake2 ffmpeg
1463 lfsmake2 vdr
1464 lfsmake2 vdr_streamdev
489145db
MT
1465 lfsmake2 vdr_epgsearch
1466 lfsmake2 vdr_dvbapi
1467 lfsmake2 vdr_eepg
1468 lfsmake2 w_scan
1469 lfsmake2 icecast
1470 lfsmake2 icegenerator
1471 lfsmake2 mpd
1472 lfsmake2 libmpdclient
1473 lfsmake2 mpc
985741db 1474 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1475 lfsmake2 perl-Net-SMTP-SSL
1476 lfsmake2 perl-MIME-Base64
1477 lfsmake2 perl-Authen-SASL
1478 lfsmake2 perl-MIME-Lite
1479 lfsmake2 perl-Email-Date-Format
1480 lfsmake2 git
1481 lfsmake2 squidclamav
1482 lfsmake2 vnstat
1483 lfsmake2 iw
1484 lfsmake2 wpa_supplicant
1485 lfsmake2 hostapd
1486 lfsmake2 pycurl
1487 lfsmake2 urlgrabber
1488 lfsmake2 syslinux
1489 lfsmake2 tftpd
1490 lfsmake2 cpufrequtils
1491 lfsmake2 bluetooth
1492 lfsmake2 gutenprint
1493 lfsmake2 apcupsd
1494 lfsmake2 iperf
1495 lfsmake2 iperf3
1496 lfsmake2 7zip
1497 lfsmake2 lynis
1498 lfsmake2 streamripper
1499 lfsmake2 sshfs
1500 lfsmake2 taglib
489145db
MT
1501 lfsmake2 sslh
1502 lfsmake2 perl-gettext
1503 lfsmake2 perl-Sort-Naturally
1504 lfsmake2 vdradmin
489145db 1505 lfsmake2 perl-DBI
489145db
MT
1506 lfsmake2 perl-DBD-SQLite
1507 lfsmake2 perl-File-ReadBackwards
489145db 1508 lfsmake2 openvmtools
489145db
MT
1509 lfsmake2 motion
1510 lfsmake2 joe
1511 lfsmake2 monit
1512 lfsmake2 nut
1513 lfsmake2 watchdog
1514 lfsmake2 libpri
1515 lfsmake2 libsrtp
1516 lfsmake2 asterisk
489145db
MT
1517 lfsmake2 usb_modeswitch
1518 lfsmake2 usb_modeswitch_data
1519 lfsmake2 zerofree
489145db
MT
1520 lfsmake2 minicom
1521 lfsmake2 ddrescue
489145db
MT
1522 lfsmake2 miniupnpd
1523 lfsmake2 client175
1524 lfsmake2 powertop
1525 lfsmake2 parted
1526 lfsmake2 swig
2a0947f2 1527 lfsmake2 u-boot
bf1e7598 1528 lfsmake2 u-boot-kirkwood
6836e528 1529 lfsmake2 u-boot-friendlyarm
5c82a9f0 1530 lfsmake2 python-typing
489145db
MT
1531 lfsmake2 python-m2crypto
1532 lfsmake2 wireless-regdb
1533 lfsmake2 crda
1534 lfsmake2 libsolv
1535 lfsmake2 python-distutils-extra
1536 lfsmake2 python-lzma
1537 lfsmake2 python-progressbar
1538 lfsmake2 python-xattr
1539 lfsmake2 ddns
2d17377a 1540 lfsmake2 python3-setuptools
662b2a81 1541 lfsmake2 python3-setuptools-scm
9e25fe5c 1542 lfsmake2 python3-six
e0a05a80 1543 lfsmake2 python3-dateutil
d48ea6b5 1544 lfsmake2 python3-jmespath
a33ca4cc 1545 lfsmake2 python3-colorama
041d2116 1546 lfsmake2 python3-docutils
d2da17a1 1547 lfsmake2 python3-yaml
953f6f73 1548 lfsmake2 python3-s3transfer
d45d5247 1549 lfsmake2 python3-rsa
faa5472a 1550 lfsmake2 python3-pyasn1
4ab80c5d 1551 lfsmake2 python3-botocore
3be81987 1552 lfsmake2 python3-llfuse
def9f4a3 1553 lfsmake2 python3-msgpack
280ee7e7 1554 lfsmake2 aws-cli
489145db
MT
1555 lfsmake2 transmission
1556 lfsmake2 dpfhack
1557 lfsmake2 lcd4linux
1558 lfsmake2 mtr
489145db
MT
1559 lfsmake2 minidlna
1560 lfsmake2 acpid
1561 lfsmake2 fping
1562 lfsmake2 telnet
1563 lfsmake2 xinetd
1564 lfsmake2 gpgme
1565 lfsmake2 pygpgme
1566 lfsmake2 pakfire3
1567 lfsmake2 stress
1568 lfsmake2 libstatgrab
1569 lfsmake2 sarg
1570 lfsmake2 check_mk_agent
1571 lfsmake2 nginx
1572 lfsmake2 sendEmail
1573 lfsmake2 sysbench
1574 lfsmake2 strace
489145db
MT
1575 lfsmake2 ltrace
1576 lfsmake2 ipfire-netboot
1577 lfsmake2 lcdproc
1578 lfsmake2 bitstream
1579 lfsmake2 multicat
1580 lfsmake2 keepalived
1581 lfsmake2 ipvsadm
1582 lfsmake2 perl-Carp-Clan
1583 lfsmake2 perl-Date-Calc
1584 lfsmake2 perl-Date-Manip
1585 lfsmake2 perl-File-Tail
1586 lfsmake2 perl-TimeDate
1587 lfsmake2 swatch
1588 lfsmake2 tor
1589 lfsmake2 arm
1590 lfsmake2 wavemon
1591 lfsmake2 iptraf-ng
1592 lfsmake2 iotop
1593 lfsmake2 stunnel
489145db
MT
1594 lfsmake2 bacula
1595 lfsmake2 batctl
b62c826f
MT
1596 lfsmake2 perl-Font-TTF
1597 lfsmake2 perl-IO-String
489145db
MT
1598 lfsmake2 perl-PDF-API2
1599 lfsmake2 squid-accounting
1600 lfsmake2 pigz
1601 lfsmake2 tmux
1602 lfsmake2 perl-Text-CSV_XS
489145db
MT
1603 lfsmake2 haproxy
1604 lfsmake2 ipset
1605 lfsmake2 lua
1606 lfsmake2 dnsdist
1607 lfsmake2 bird
1a7db134 1608 lfsmake2 frr
489145db
MT
1609 lfsmake2 dmidecode
1610 lfsmake2 mcelog
1611 lfsmake2 rtpproxy
1612 lfsmake2 util-macros
1613 lfsmake2 libpciaccess
1614 lfsmake2 libyajl
1615 lfsmake2 libvirt
1616 lfsmake2 freeradius
1617 lfsmake2 perl-common-sense
1618 lfsmake2 perl-inotify2
1619 lfsmake2 perl-Net-IP
0d6cc79d 1620 lfsmake2 wio
773caa66 1621 lfsmake2 iftop
ddcd60f7 1622 lfsmake2 mdns-repeater
429af178 1623 lfsmake2 i2c-tools
4e9000b4 1624 lfsmake2 nss-myhostname
014b235a 1625 lfsmake2 dehydrated
c708fa15 1626 lfsmake2 shairport-sync
46114d79 1627 lfsmake2 borgbackup
2397e513 1628 lfsmake2 knot
e1982c69 1629 lfsmake2 spectre-meltdown-checker
06fc6170 1630 lfsmake2 zabbix_agentd
82d176d3 1631 lfsmake2 flashrom
2aca6aa0 1632 lfsmake2 firmware-update
ffcef39d 1633 lfsmake2 tshark
392994dc 1634 lfsmake2 geoip-generator
9875e9f2 1635 lfsmake2 speedtest-cli
0db643ce 1636 lfsmake2 rfkill
44cc9a3d 1637 lfsmake2 amazon-ssm-agent
d0817963 1638}
df5e82b3
MT
1639
1640buildinstaller() {
1641 # Run installer scripts one by one
ebaecf2c 1642 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1643 export LOGFILE
489145db
MT
1644 lfsmake2 memtest
1645 lfsmake2 installer
ce9264a1
AF
1646 # use toolchain bash for chroot to strip
1647 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1648}
1649
1650buildpackages() {
ebaecf2c 1651 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1652 export LOGFILE
1653 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1654
df5e82b3
MT
1655
1656 # Generating list of packages used
dc4ae0b7 1657 print_line "Generating packages list from logs"
df5e82b3 1658 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1659 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1660 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1661 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1662 fi
1663 done
7471f6ab 1664 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1665 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1666 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1667 rm -f $BASEDIR/doc/packages-list
c9673262 1668 # packages-list.txt is ready to be displayed for wiki page
f9783277 1669 print_status DONE
4b06f504
MT
1670
1671 # Update changelog
e49f7f0d 1672 cd $BASEDIR
c43b07fd
AF
1673 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1674 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1675 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1676
9607771a 1677 # Create images for install
489145db 1678 lfsmake2 cdrom
bada0832 1679
4dc82852 1680 # Check if there is a loop device for building in virtual environments
841663e7
MT
1681 modprobe loop 2>/dev/null
1682 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1683 lfsmake2 flash-images
4dc82852 1684 fi
c9673262 1685
c4dd9dfc 1686 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1687
0d909a4a 1688 ipfirepackages
e67a57fe 1689
489145db 1690 lfsmake2 xen-image
939c2a21 1691 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
bada0832 1692
b307417f 1693 cd $BASEDIR
744a04ea
AF
1694
1695 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1696 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1697
92244a40 1698 for i in `ls *.bz2 *.img.xz *.iso`; do
b307417f
AF
1699 md5sum $i > $i.md5
1700 done
1701 cd $PWD
1702
e67a57fe
MT
1703 # Cleanup
1704 stdumount
1705 rm -rf $BASEDIR/build/tmp/*
1706
e67a57fe 1707 cd $PWD
e67a57fe
MT
1708}
1709
1710ipfirepackages() {
489145db 1711 lfsmake2 core-updates
5596077b
MT
1712
1713 local i
dc7d6b20 1714 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1715 i=$(basename ${i})
453b418b
MT
1716 if [ -e $BASEDIR/lfs/$i ]; then
1717 ipfiredist $i
1718 else
1719 echo -n $i
f9783277 1720 print_status SKIP
453b418b 1721 fi
fe7fe395 1722 done
78331e30 1723 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1724 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1725 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1726}
1727
bcb9dc13
MT
1728while [ $# -gt 0 ]; do
1729 case "${1}" in
1730 --target=*)
c2e810de 1731 configure_build "${1#--target=}"
bcb9dc13
MT
1732 ;;
1733 -*)
1734 exiterror "Unknown configuration option: ${1}"
1735 ;;
1736 *)
1737 # Found a command, so exit options parsing.
1738 break
1739 ;;
1740 esac
1741 shift
1742done
1743
df5e82b3
MT
1744# See what we're supposed to do
1745case "$1" in
1746build)
f9783277
MT
1747 START_TIME=$(now)
1748
1749 # Clear screen
1750 ${INTERACTIVE} && clear
1751
f74072a2 1752 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1753 #only restore on a clean disk
6c4cc7ea 1754 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1755 if [ ! -n "$PACKAGE" ]; then
f9783277 1756 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1757 prepareenv
1758 buildtoolchain
1759 else
f74072a2 1760 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1761 print_build_stage "Packaged toolchain compilation"
df5e82b3 1762 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1763 tar axf $PACKAGE
df5e82b3
MT
1764 prepareenv
1765 else
1766 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1767 fi
1768 fi
1769 else
df5e82b3
MT
1770 prepareenv
1771 fi
5cfe86e6 1772
f9783277 1773 print_build_stage "Building LFS"
df5e82b3 1774 buildbase
15679d9f 1775
f9783277 1776 print_build_stage "Building IPFire"
15679d9f 1777 buildipfire
5cfe86e6 1778
f9783277 1779 print_build_stage "Building installer"
df5e82b3 1780 buildinstaller
15679d9f 1781
f9783277 1782 print_build_stage "Building packages"
df5e82b3 1783 buildpackages
7a5ed24e 1784
f9783277 1785 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1786
1787 cd $BASEDIR
7a5ed24e 1788 tools/checknewlog.pl
e0c923f4 1789 tools/checkrootfiles
b307417f 1790 cd $PWD
a23731d1 1791
f9783277 1792 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1793 ;;
1794shell)
1795 # enter a shell inside LFS chroot
1796 # may be used to changed kernel settings
1797 prepareenv
1798 entershell
1799 ;;
df5e82b3 1800clean)
f9783277
MT
1801 print_line "Cleaning build directory..."
1802
df5e82b3
MT
1803 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1804 $LOSETUP -d $i 2>/dev/null
1805 done
1806 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1807 umount $i
1808 done
1809 stdumount
1810 for i in `seq 0 7`; do
69a6ec55 1811 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1812 umount /dev/loop${i} 2>/dev/null;
1813 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1814 fi;
df5e82b3
MT
1815 done
1816 rm -rf $BASEDIR/build
1817 rm -rf $BASEDIR/cdrom
f9315063 1818 rm -rf $BASEDIR/packages
ebaecf2c 1819 rm -rf $BASEDIR/log
6c4cc7ea
MT
1820 if [ -h "${TOOLS_DIR}" ]; then
1821 rm -f "${TOOLS_DIR}"
df5e82b3 1822 fi
b307417f 1823 rm -f $BASEDIR/ipfire-*
f9783277 1824 print_status DONE
df5e82b3 1825 ;;
4e432799
MT
1826docker)
1827 # Build the docker image if it does not exist, yet
1828 if ! docker images -a | grep -q ^ipfire-builder; then
1829 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1830 print_status DONE
1831 else
1832 print_status FAIL
1833 exit 1
1834 fi
1835 fi
1836
1837 # Run the container and enter a shell
1838 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1839 ;;
c3db995c 1840downloadsrc)
df5e82b3
MT
1841 if [ ! -d $BASEDIR/cache ]; then
1842 mkdir $BASEDIR/cache
1843 fi
ebaecf2c 1844 mkdir -p $BASEDIR/log
857d9bf2 1845 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1846 FINISHED=0
1847 cd $BASEDIR/lfs
1848 for c in `seq $MAX_RETRIES`; do
1849 if (( FINISHED==1 )); then
1850 break
1851 fi
1852 FINISHED=1
1853 cd $BASEDIR/lfs
1854 for i in *; do
1855 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1856 lfsmakecommoncheck ${i} || continue
1857
dc7d6b20 1858 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1859 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1860 if [ $? -ne 0 ]; then
f9783277 1861 print_status FAIL
df5e82b3
MT
1862 FINISHED=0
1863 else
1864 if [ $c -eq 1 ]; then
f9783277 1865 print_status DONE
df5e82b3
MT
1866 fi
1867 fi
1868 fi
1869 done
1870 done
e22c7973 1871 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1872 ERROR=0
1873 for i in *; do
1874 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1875 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1876 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1877 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1878 if [ $? -ne 0 ]; then
e22c7973 1879 echo -ne "MD5 difference in lfs/$i"
f9783277 1880 print_status FAIL
df5e82b3
MT
1881 ERROR=1
1882 fi
1883 fi
1884 done
1885 if [ $ERROR -eq 0 ]; then
e22c7973 1886 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1887 print_status DONE
e22c7973
MT
1888 else
1889 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1890 print_status FAIL
df5e82b3 1891 fi
e22c7973 1892 cd - >/dev/null 2>&1
df5e82b3 1893 ;;
df5e82b3 1894toolchain)
f9783277
MT
1895 # Clear screen
1896 ${INTERACTIVE} && clear
1897
df5e82b3 1898 prepareenv
f3b7cf47 1899 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1900 buildtoolchain
f74072a2 1901 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1902 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
ebaecf2c 1903 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
b46f951e 1904 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
f74072a2 1905 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1906 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1907 stdumount
1908 ;;
1909gettoolchain)
df5e82b3 1910 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1911 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1912 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1913 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1914 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1915 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1916 cd $BASEDIR/cache/toolchains
f74072a2 1917 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1918 if [ $? -ne 0 ]; then
dc7d6b20 1919 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1920 else
f74072a2 1921 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1922 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1923 else
1924 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1925 fi
40a4ea4c 1926 fi
712d859c
MT
1927 else
1928 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1929 fi
1930 ;;
15679d9f
MT
1931uploadsrc)
1932 PWD=`pwd`
661d9388
CS
1933 if [ -z $IPFIRE_USER ]; then
1934 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1935 print_status FAIL
661d9388
CS
1936 exit 1
1937 fi
ae23a606 1938
661d9388 1939 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1940 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1941
15e38431
MT
1942 for file in ${BASEDIR}/cache/*; do
1943 [ -d "${file}" ] && continue
1944 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1945 NEW_FILES="$NEW_FILES $file"
0eab8e84 1946 done
661d9388
CS
1947 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1948 cd $BASEDIR
15679d9f
MT
1949 cd $PWD
1950 exit 0
0eab8e84 1951 ;;
bf7c473f 1952lang)
69a6ec55
MT
1953 echo -ne "Checking the translations for missing or obsolete strings..."
1954 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1955 $BASEDIR/tools/sort_strings.pl en
1956 $BASEDIR/tools/sort_strings.pl de
1957 $BASEDIR/tools/sort_strings.pl fr
1958 $BASEDIR/tools/sort_strings.pl es
1959 $BASEDIR/tools/sort_strings.pl pl
1960 $BASEDIR/tools/sort_strings.pl ru
1961 $BASEDIR/tools/sort_strings.pl nl
1962 $BASEDIR/tools/sort_strings.pl tr
1963 $BASEDIR/tools/sort_strings.pl it
1964 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1965 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1966 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1967 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1968 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1969 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1970 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1971 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1972 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1973 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1974 print_status DONE
69a6ec55
MT
1975
1976 echo -ne "Updating language lists..."
1977 update_language_list ${BASEDIR}/src/installer/po
1978 update_language_list ${BASEDIR}/src/setup/po
f9783277 1979 print_status DONE
bf7c473f 1980 ;;
1fb7f56e
MT
1981update-contributors)
1982 update_contributors
1983 ;;
6b8cff41 1984*)
1fb7f56e 1985 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
6b8cff41
MT
1986 cat doc/make.sh-usage
1987 ;;
3ea75603 1988esac